# Copyright 2021- Le Filament (https://le-filament.com)
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl.html)

from odoo import fields, models


class ResConfig(models.TransientModel):
    _inherit = "res.config.settings"
    _description = "Sharepoint parameter"

    admin_sharepoint_user_id = fields.Char("User sharepoint")
    admin_sharepoint_secret_id = fields.Char("Secret sharepoint")

    # ------------------------------------------------------
    # SQL Constraints
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Default methods
    # ------------------------------------------------------
    def get_values(self):
        res = super().get_values()
        admin_sharepoint_user_id = self.env["ir.config_parameter"].get_param(
            "siof_sharepoint.admin_sharepoint_user_id", default=""
        )
        admin_sharepoint_secret_id = self.env["ir.config_parameter"].get_param(
            "siof_sharepoint.admin_sharepoint_secret_id", default=""
        )
        res.update(
            admin_sharepoint_user_id=admin_sharepoint_user_id,
            admin_sharepoint_secret_id=admin_sharepoint_secret_id,
        )
        return res

    def set_values(self):
        self.env["ir.config_parameter"].set_param(
            "siof_sharepoint.admin_sharepoint_user_id", self.admin_sharepoint_user_id
        )

        self.env["ir.config_parameter"].set_param(
            "siof_sharepoint.admin_sharepoint_secret_id",
            self.admin_sharepoint_secret_id,
        )

        return super().set_values()

    # ------------------------------------------------------
    # Computed fields / Search Fields
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Onchange / Constraints
    # ------------------------------------------------------

    # ------------------------------------------------------
    # CRUD methods (ORM overrides)
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Actions
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Business methods
    # ------------------------------------------------------
